highp vec4 computeCurvature(highp vec4 posW, highp vec3 cameraPos, highp vec3 cameraFront, highp float wavelength, highp float amplitude)
{
	highp vec3 dir = posW.xyz - cameraPos;
	highp float dist = dot(dir, cameraFront);

	highp float X = dist / max(wavelength, 1.0);
	X = X * X;

	highp float modulation = X * amplitude;

	return posW + vec4(0.0, 0.0, modulation, 0.0);
}